<template>
  <div v-if="isFinish" style="height: 100%;">
    <Screen v-if="screening" />
    <Market v-else-if="market"></Market>
    <Editor v-else-if="_isPC" />
    <Mobile v-else />
  </div>
</template>

<script lang="ts" setup>
import { onMounted,ref,provide } from 'vue'
import { storeToRefs } from 'pinia'
import { useScreenStore, useMainStore, useSnapshotStore } from '@/store'
import { LOCALSTORAGE_KEY_DISCARDED_DB } from '@/configs/storage'
import { deleteDiscardedDB } from '@/utils/database'
import { isPC, query } from './utils/common'
import { userStore } from './store/user'
import { injectKeyTemplate } from '@/types/injectKey'

import Editor from './views/Editor/index.vue'
import Screen from './views/Screen/index.vue'
import Mobile from './views/Mobile/index.vue'
import Market from './views/Market/Index.vue'

const searchData = ref({} as any)
provide(injectKeyTemplate,searchData)

const isFinish = ref(false)


const _isPC = isPC()

const mainStore = useMainStore()
const snapshotStore = useSnapshotStore()
const modelStore = useScreenStore()
const ConfigIdStore = useScreenStore()
const { databaseId } = storeToRefs(mainStore)
const { screening, market, model, ConfigId } = storeToRefs(useScreenStore())

if (process.env.NODE_ENV === 'production') {
  window.onbeforeunload = () => false
}

const userLoginHandler = async ()=>{
  let param = query()
  
  let userId = 1
  let ConfigId = 0
  let model = 1
  if(param.uid) userId=parseInt(param.uid)
  if(ConfigId) ConfigIdStore.setConfigId(ConfigId)
  if(model) modelStore.setModel(model)
  try {
     await userStore().setUserLoginAsync(userId)
  } catch (error) {
    
  }
  isFinish.value=true
}
userLoginHandler()

onMounted(async () => {
  await deleteDiscardedDB()
  snapshotStore.initSnapshotDatabase()
  mainStore.setAvailableFonts()
})

// 应用注销时向 localStorage 中记录下本次 indexedDB 的数据库ID，用于之后清除数据库
window.addEventListener('unload', () => {
  const discardedDB = localStorage.getItem(LOCALSTORAGE_KEY_DISCARDED_DB)
  const discardedDBList: string[] = discardedDB ? JSON.parse(discardedDB) : []

  discardedDBList.push(databaseId.value)

  const newDiscardedDB = JSON.stringify(discardedDBList)
  localStorage.setItem(LOCALSTORAGE_KEY_DISCARDED_DB, newDiscardedDB)
})
</script>

<style lang="scss">
#app {
  height: 100%;
}
</style>